/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.stimmzettel.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum;
import de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumUK;

public abstract class AbstractStimmzettelKopfdatumDAO extends de.ivu.elect.jee.entity.AbstractDAO<StimmzettelKopfdatum,
        de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK
    , StimmzettelKopfdatumUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractStimmzettelKopfdatumDAO.class);

  public AbstractStimmzettelKopfdatumDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public StimmzettelKopfdatum findByPrimaryKey(
        de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected StimmzettelKopfdatum findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(StimmzettelKopfdatum.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: ByGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM StimmzettelKopfdatum o WHERE o.gebiet = ?1<br>
      * SQL: <br>
      */
     public Integer deleteByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL_KOPFDATUM.ByGebiet")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("StimmzettelKopfdatum, deleteByGebiet - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: GebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StimmzettelKopfdatum o WHERE o.gebiet = ?1<br>
      * SQL: <br>
      */
     public java.util.List<StimmzettelKopfdatum> findByGebiet( @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL_KOPFDATUM.Gebiet")
                              .setParameter(1, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmzettelKopfdatum, findByGebiet - NonUniqueResultException, Parameter: "
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: SchluesselGebietGruppeNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StimmzettelKopfdatum o WHERE o.schluessel = ?1 AND o.gebiet = ?2 AND gruppe = ?3<br>
      * SQL: <br>
      */
     public StimmzettelKopfdatum findBySchluesselGebietGruppe( @javax.annotation.Nonnull String schluessel,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  String schluesselCheckedAndAttached =  checkAndAttach(schluessel, String.class, "schluessel"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  
                              return
                    (StimmzettelKopfdatum)
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL_KOPFDATUM.SchluesselGebietGruppe")
                              .setParameter(1, schluesselCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                        .setParameter(3, gruppeCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findBySchluesselGebietGruppe - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmzettelKopfdatum, findBySchluesselGebietGruppe - NonUniqueResultException, Parameter: "
           + ", schluessel:'"+schluessel+"'"
           + ", gebiet:'"+gebiet+"'"
           + ", gruppe:'"+gruppe+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findBySchluesselGebietGruppe(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: SchluesselGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StimmzettelKopfdatum o WHERE o.schluessel = ?1 AND o.gebiet = ?2 AND gruppe IS NULL<br>
      * SQL: <br>
      */
     public StimmzettelKopfdatum findBySchluesselGebiet( @javax.annotation.Nonnull String schluessel,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  String schluesselCheckedAndAttached =  checkAndAttach(schluessel, String.class, "schluessel"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                    (StimmzettelKopfdatum)
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL_KOPFDATUM.SchluesselGebiet")
                              .setParameter(1, schluesselCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findBySchluesselGebiet - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmzettelKopfdatum, findBySchluesselGebiet - NonUniqueResultException, Parameter: "
           + ", schluessel:'"+schluessel+"'"
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findBySchluesselGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: WahlNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM StimmzettelKopfdatum o WHERE o.gebiet.wahl=?1<br>
      * SQL: <br>
      */
     public java.util.List<StimmzettelKopfdatum> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMZETTEL_KOPFDATUM.Wahl")
                              .setParameter(1, wahlCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByWahl - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("StimmzettelKopfdatum, findByWahl - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByWahl(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumUK uk,
        de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum findByUK(de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatumUK uk){

    try {
     return (de.ivu.elect.business.stimmzettel.entity.StimmzettelKopfdatum) getEntityManager().createNamedQuery("STIMMZETTEL_KOPFDATUM.UK")
                  .setParameter(1, uk
                .getSchluessel ()  
              )
             .setParameter(2, uk
                .getGebietUK ()  
                .getNummer ()  
              )
             .setParameter(3, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getName ()  
              )
             .setParameter(4, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(5, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(6, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(7, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(8, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(9, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(10, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(11, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(12, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(13, uk
                .getGruppeUK ()  
                .getSchluessel ()  
              )
             .setParameter(14, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(15, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(16, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(17, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(18, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("StimmzettelKopfdatum, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}